

# NOTE: This only works on LINUX, due to access limits on Windows
# Works on FibreCode network-adapters FC602 (100BASE-T1) and FC621 (10BASE-T1L)
#

import os, sys
import time
import socket
import struct
import binascii

#DevName = 'eth0'
DevName = 'enx9ca2f4b61a20'

# creating a rawSocket for communications
# PF_SOCKET (packet interface), SOCK_RAW (Raw socket) - htons (protocol) 0x08000 = IP Protocol

ETH_P_ALL = 3
ETH_P_IP = 0x800


def check_receive_data(frameId, rxData):
    # verify contents of loop-back
    
    
    txD = binascii.b2a_hex(txData[18:26])
    
    print('Tx-FrameId: {0}'.format(txD))
    
    return 1



try:
    rawSocketRx = socket.socket(socket.PF_PACKET, socket.SOCK_RAW, socket.htons(ETH_P_ALL)) #, socket.htons(0x0800))  #  htons(ETH_P_802_2))
except:
    print('socket creation failed!. Is this MS-Windows maybe!')
    sys.exit(-1)

rawSocketRx.bind((DevName, 0))
rawSocketRx.settimeout(1.0)


rxFrameId = -1

try:
    while True:

        try:
            rawData = rawSocketRx.recv(4096) # tuple return
            time.sleep(0)
        except:
            time.sleep(0.5)
            continue
        
        print(len(rawData))
        
        # Ethernet Header tuple segmentation
        eHeader = binascii.b2a_hex(rawData[0:14])
        tgtAddr = eHeader[0:12]
        srcAddr = eHeader[12:24]
        ethType = eHeader[24:28]
        
        magicId = int.from_bytes(rawData[14:16], byteorder='big')
        frameId = int.from_bytes(rawData[20:28], byteorder='little')
        
        ethFrameData = binascii.b2a_hex(rawData[16:])
        print(ethFrameData)
        
        print(hex(magicId), frameId)
        

       	# parsing using unpack
        print('Tgt:{0} Src:{1} Type:{2}'.format(tgtAddr, srcAddr, ethType))

except KeyboardInterrupt:
    rawSocketRx.close()
    
