# NOTE: This only works on LINUX, due to access limits on Windows
# Works on FibreCode network-adapters FC602 (100BASE-T1) and FC621 (10BASE-T1L) also
#
# Verified on Ubuntu 22.04 Virual Machine using USB3-TP-Link Adapter

# Modify DevName to connected MAC/Network-Card


import os, sys
import time
import socket
import struct
import binascii

#DevName = 'eth0'
DevName = 'enx9ca2f4b61a20'

# creating a rawSocket for communications
# PF_SOCKET (packet interface), SOCK_RAW (Raw socket) - htons (protocol) 0x08000 = IP Protocol

ETH_P_ALL = 3
ETH_P_IP = 0x0800

try:
    rawSocketTx = socket.socket(socket.PF_PACKET, socket.SOCK_RAW, socket.htons(ETH_P_ALL))
except:
    print('Tx socket creation failed!. Is this MS-Windows maybe!')
    sys.exit(-1)


try:
    rawSocketRx = socket.socket(socket.PF_PACKET, socket.SOCK_RAW, socket.htons(ETH_P_ALL))
except:
    print('Rx socket creation failed!. Is this MS-Windows maybe!')
    sys.exit(-1)

# bind Tx-Socket to correct DevName
rawSocketTx.bind((DevName, 0))

# bind Rx-Socket to correct DevName
rawSocketRx.bind((DevName, 0))
rawSocketRx.settimeout(1.0)

# create a ethernet packet
payload = 128 # 1492
macBroadcast = 'FFFFFFFFFFFF'
macSrc = 'FC0011223344'


payloadData = ''
for j in range(0, payload):
    payloadData += '{0:02X}'.format(j & 0xFF)


frameId = 1
errCnt = 0

def check_receive_data(frameId, txData, rxData):
    # verify contents of loop-back
    
    try:
        frame1 = rxData[0]
        frame2 = rxData[2]
    except:
        return 100
    
    txD = binascii.b2a_hex(txData[18:26])
    
    print('Tx-FrameId: {0}'.format(txD))
    
    return 1
     

print('Send/Receive Raw-Frames on {0}'.format(DevName))

try:
    while True:

        #sendData = 'FFFFFFFFFFFF' + macSrc + '{0:04X}'.format(payload) + '1234' + '{0:08X}'.format(frameId) + '{0:04X}'.format(payload+6) + payloadData
        sendData = macBroadcast + macSrc + '{0:04X}'.format(payload) + '1234' + '{0:08X}'.format(frameId) + '{0:04X}'.format(payload+6) + payloadData

        binData = binascii.a2b_hex(sendData)
        # 6 dest address, 6 source address and 2 for ethtype = IP

        # send preapred data incl. frameId as running counter
        rawSocketTx.send(binData)
        
        time.sleep(0.1)
        
        dataFrames = []
        while True:
            try:
                rawData = rawSocketRx.recv(2048) # receive pure Eth-Frame
                ethHeadRx = binascii.b2a_hex(rawData[0:14])
                print(ethHeadRx[0:12])
                print(ethHeadRx[12:24])
                
                if ethHeadRx[12:14] == b'fc':
                    dataFrames.append(rawData)
            except:
                time.sleep(0.5)
                pass
                
            if len(dataFrames) == 2:
                break
                
            time.sleep(0.1)
        
        print('Data-Frames: {0}'.format(dataFrames))
             
        errCnt = errCnt + check_receive_data(frameId, binData, dataFrames)

        print('Status: FrameId:{0} ErrCnt:{1}'.format(frameId, errCnt))

        # Ethernet Header tuple segmentation
        #eHeader1 = binascii.b2a_hex(rawData1[0:14])
        #eHeader2 = binascii.b2a_hex(rawData2[0:14])
                

        frameId += 1


except KeyboardInterrupt:
    rawSocketRx.close()
    rawSocketTx.close()
    
